package com.sun.corba.se.impl.naming.namingutil;

import org.omg.CORBA.DATA_CONVERSION;
import java.io.StringWriter;
import com.sun.corba.se.impl.logging.NamingSystemException;

class Utility
{
    private static NamingSystemException wrapper;
    
    Utility() {
    }
    
    static String cleanEscapes(String s) {
        StringWriter stringWriter = new StringWriter();
        for (int i = 0; i < s.length(); ++i) {
            int char1 = s.charAt(i);
            if (char1 != '%') {
                stringWriter.write(char1);
            }
            else {
                ++i;
                int hex = hexOf(s.charAt(i));
                ++i;
                stringWriter.write((int)(char)(hex * 16 + hexOf(s.charAt(i))));
            }
        }
        return stringWriter.toString();
    }
    
    static int hexOf(char c) {
        int n = c - 48;
        if (n >= 0 && n <= 9) {
            return n;
        }
        int n2 = c - 97 + 10;
        if (n2 >= 10 && n2 <= 15) {
            return n2;
        }
        int n3 = c - 65 + 10;
        if (n3 >= 10 && n3 <= 15) {
            return n3;
        }
        throw new DATA_CONVERSION();
    }
    
    static void validateGIOPVersion(IIOPEndpointInfo iiopEndpointInfo) {
        if (iiopEndpointInfo.getMajor() > 1 || iiopEndpointInfo.getMinor() > 2) {
            throw Utility.wrapper.insBadAddress();
        }
        return;
    }
    
    static {
        Utility.wrapper = NamingSystemException.get("naming");
    }
}
